<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * Installationsskript
 */


// includes
require("../settings/admin.php");
require("../settings/php.php");
require("../classes/class.ctlVar.php");
require("../classes/class.db.php");
require("../classes/class.out.php");
require("../classes/class.phpmailer.php");
require("../classes/class.settings.php");
require("../includes/functions.php");
require("../includes/funcOutput.php");

$myDB  = new db($server, $username, $pass, $dbase, $prefix, $MySQL_Ver);
$out   = new out( "  ", 0 );
$settings = new settings( $myDB, TRUE );
$settings->standardStyle = "../styles/style01.css";
$settings->browserTitel = "Filmverwaltung mit PHP &amp; MySQL";
$myVar = new ctlVar($settings,$myDB,$COOCKIES_ACTIVE,TRUE);


//$myVar->crtlGetPostData( $myDB, $settings );
$out->startBuffer();

if ( isset($_REQUEST['sent']) )
{
        // neue Tabellen erstellen
        if ($_REQUEST['Res'] == 1) {
        $sql = "ALTER TABLE $myDB->RESERVIERUNG ADD AdminMessage INT( 10 ) UNSIGNED NOT NULL DEFAULT '0'";
        $rs = $myDB->go($sql);
        }
        if ($_REQUEST['Res'] == 2) {
        $sql = "CREATE TABLE IF NOT EXISTS $myDB->RESERVIERUNG (FILME_FilmID int(10) unsigned NOT NULL, USERS_UserID int(10) unsigned NOT NULL default 0, reserviertAm date NOT NULL default '0000-00-00', AdminMessage INT( 10 ) UNSIGNED NOT NULL DEFAULT 0, PRIMARY KEY  (FILME_FilmID, USERS_UserID))";
        $rs = $myDB->go($sql);
        }
        if ($_REQUEST['Res_Usr'] == 1) {
        $sql = "ALTER TABLE $myDB->USERS ADD GetResEmails INT( 1 ) UNSIGNED NOT NULL DEFAULT '1'";
        $rs = $myDB->go($sql);
        }
        if ($_REQUEST['Res_Ses'] == 1) {
        $sql = "ALTER TABLE $myDB->USERS ADD lastActive INT( 10 ) UNSIGNED NOT NULL DEFAULT '0' AFTER lastLogin";
        $rs = $myDB->go($sql);
        }
        if ($_REQUEST['Res_Own'] == 1) {
        $sql = "ALTER TABLE $myDB->USERS ADD ownFilms INT( 1 ) UNSIGNED NOT NULL DEFAULT '0' AFTER UserRechte";
        $rs = $myDB->go($sql);
        }
        if ($_REQUEST['Fsk'] == 1) {
        $sql = "INSERT DELAYED IGNORE INTO $myDB->SETTINGS (Variable, Wert) VALUES
        ('ModFSK', TRUE)";
        $rs = $myDB->go($sql);
        }
       
    if ( count( $myVar->warnung ) )
        unset($_REQUEST['sent']);
}


// Hier werden Ausgaben fr das Men gemacht
printHeader( $settings );
echo "<div id=\"seite\">";
printTopLogin( $myVar, $settings );

echo "<div id=\"untermenu\">";
echo "<ul>";

echo "</ul>";
echo "</div>";



if ( count( $myVar->warnung ) )
{
    echo "<ul class=\"message\" style=\"background-color:#f88\">";
    for ( $i=0; $i<count( $myVar->warnung ); ++$i )
        echo "<li>".$myVar->warnung[$i]."</li>";
    echo "</ul>";
}

if ( count( $myVar->hinweis ) )
{
    echo "<ul class=\"message\" style=\"background-color:#ffa\">";
    for ( $i=0; $i<count( $myVar->hinweis ); ++$i )
        echo "<li>".$myVar->hinweis[$i]."</li>";
    echo "</ul>";
}


echo "<div id=\"inhalt\">";
// Hier die Prfungen, wie de DB derzeit aussieht
$Res = "2";
$Fsk = "1";
$Res_Usr = "1";
$Res_Ses = "1";
$Res_Own = "1";
$sql = "SHOW TABLES FROM $dbase";
$rs = $myDB->go($sql);
while ( $row = $myDB->getRow($rs)) {

    if ( $row[Tables_in_.$dbase] == $myDB->RESERVIERUNG  ) {
        $sql2 = "SHOW COLUMNS FROM $myDB->RESERVIERUNG";
        $rs2 = $myDB->go($sql2);
        while ( $row2 = $myDB->getRow($rs2)) {
            if ( $row2[Field] == AdminMessage  ) {
            $Res = "0";
            } else {
            $Res = "1";
            }
        }
    }

    if ( $row[Tables_in_.$dbase] == $myDB->USERS  ) {
        $sql4 = "SHOW COLUMNS FROM $myDB->USERS";
        $rs4 = $myDB->go($sql4);
        while ( $row4 = $myDB->getRow($rs4)) {
            if ( $row4[Field] == getResEmails  ) {
            $Res_Usr = "0";
            }
            if ( $row4[Field] == lastActive  ) {
            $Res_Ses = "0";
            }
            if ( $row4[Field] == ownFilms  ) {
            $Res_Own = "0";
            }    
        }
    }           
    
    if ( $row[Tables_in_.$dbase] == $myDB->SETTINGS  ) {
        $sql3 = "SELECT Variable FROM $myDB->SETTINGS WHERE Variable = 'ModFSK'";
        $rs3 = $myDB->go($sql3);
        $row3 = $myDB->getRow($rs3);
        if ($row3['Variable'] == ModFSK) {
            $Fsk = "0";
        } 
    }
}
if ($Res == 0 && $Fsk == 0 && $Res_Usr == 0 && $Res_Ses == 0 && $Res_Own == 0) {
    $no_install = TRUE;
} else {
    $no_install = FALSE;
}

if ($no_install) {
    echo "<p></p>";
    echo "<h2>INSTALLATIONSVERZEICHNIS VOM SERVER L&Ouml;SCHEN!</h2>";
    echo "Keine Installation bzw. Update ntig, da bereits die aktuellste Datenbankversion installiert ist.<br/>";
} else {
if ( !isset($_REQUEST['sent']) || count( $myVar->warnung ) )
{
    echo "<p><h2>Installationsskript des Mods: Reservierung 1.5</h2></p>";
    $sql = "SELECT VERSION() AS version";
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<p>MySQL-Version ist: ".$row['version'];
    if ( (float)$row['version'] < 4.1 ) {
        echo "<br />Es scheint so, als ob es eine alte Version ist. Beachte den Eintrag in der Datei 'admin.php'! Sonst kommt es zu Fehlermeldungen.";
    }
    echo "</p>";
    echo "<p><b>VOR DEM AUSFHREN DIESES SKRIPTES EINE SICHERHEITSKOPIE DER DATENBANK MACHEN !</b><br/><br/>Diese Script nimmt automatisch die ntigen nderungen in der Datanbank vor.  Es werden neue Tabellen erstellt, sowie eventuell vorhandene Tabellen abgendert. ";
    echo "<form method=\"post\" action=\"{$_SERVER['PHP_SELF']}\">";
    echo "<p>";
// Eventuelle Ausgaben fr bessere Verstndlichekiet was innerhalb des Skriptes passiert
    if($Res == 1){
        echo "Die Tabelle fr die Reservierung ist bereits vorhaden. Jedoch fehlt die Spalte AdminMessage. Diese wird nun hinzugefgt.<br/>";
        echo "<input type=\"hidden\" name=\"Res\" value=\"1\" />";
    }
    if($Res == 2){
        echo "Der Reservierungsmod wurde auf diesem System noch nicht installiert. Daher wird nun eine neue Tabelle mit den ntigen Eintrgen angelegt.<br/>";
        echo "<input type=\"hidden\" name=\"Res\" value=\"2\" />";
    }
    if($Res_Usr == 1){
        echo "Fr die neuen MultiAdmin Cronjobs (deaktivierbar) muss ein Konfigurationseintarg innerhalb der Datenbank gesetzt werden.<br/>";
        echo "<input type=\"hidden\" name=\"Res_Usr\" value=\"1\" />";
    }
    if($Res_Ses == 1){
        echo "Damit der Cronjob erkennt ob ein User Online ist, muss ein Eintrag zu der User Tabelle hinzugefgt werden.<br/>";
        echo "<input type=\"hidden\" name=\"Res_Ses\" value=\"1\" />";
    }
    if($Res_Own == 1){
        echo "Fr die neue Admin Klasse muss ein zustzlicher Konfiguratioseintrag gesetzt werden.<br/>";
        echo "<input type=\"hidden\" name=\"Res_Own\" value=\"1\" />";
    }
    if($Fsk == 1){
        echo "Der Eintrag fr die Konfiguration der grafischen FSK Anzeige ist nicht vorhanden. Daher wird dieser nachgetragen.<br/>";
        echo "<input type=\"hidden\" name=\"Fsk\" value=\"1\" />";
    }
    echo "</p>";
    echo "<table>";
    echo "<tr>";
    echo "</table>";
    echo "<p><input type=\"hidden\" name=\"sent\" value=\"1\" /></p>";
    echo "<p style=\"margin-top:2em\"><input class=\"buttonSubmit\" type=\"submit\" name=\"sent\" value=\"Mod installieren\" /></p>";
    echo "</form>";
}
else
{
    echo "<p>Falls kein Fehler aufgetreten ist:</p>";
    echo "<h2>INSTALLATIONSVERZEICHNIS VOM SERVER L&Ouml;SCHEN!</h2>";
// Erluterung der gettigten AKtionen
    if ( isset($_REQUEST['sent']) ) {
        echo "<br/>";
        if ( $_REQUEST['Res'] == 1 ) {
            echo "Die Spalte AdminMessage wurde erfolgreich zu der Tabelle Reservierung hinzugefgt.<br/>";
        }
        if ( $_REQUEST['Res'] == 2 ) {
            echo "Die Tabelle Reservierung wurde erfolgreich angelegt.<br/>";
        }
        if ( $_REQUEST['Res_Usr'] == 1 ) {
            echo "Der Konfigurationseintrag fr die MultiAdmin Cronjobs wurde gesetzt.<br/>";
        }
        if ( $_REQUEST['Res_Ses'] == 1 ) {
            echo "Der Eintrag fr die Erkennung aktiver Sessions wurde gesetzt.<br/>";
        }
        if ( $_REQUEST['Res_Own'] == 1 ) {
            echo "Der Eintrag fr die neue Admin Klasse wurde erfolgreich gesetzt.<br/>";
        }
        if ( $_REQUEST['Fsk'] == 1 ) {
            echo "Der Konfigurationseintrag fr die grafische FSK Anzeige wurde gesetzt.<br/>";
        }
    }
}
}
echo "</div>";
/*
 * COPYRIGHT-HINWEISE DRFEN NICHT VERNDERT WERDEN!
 * LINKS AUF WWW.DER-DOMI.DE MSSEN BESTEHEN BLEIBEN!
 */
printFootline($settings);
echo "</div>";
echo "</body></html>";


$out->put( $out->endBuffer() );


?>